/****************************************Copyright (c)**************************************************
**                               Guangzhou ZHIYUAN electronics Co.,LTD.
**                                     
**                                 http://www.embedtools.com
**
**--------------File Info-------------------------------------------------------------------------------
** File Name:               Uart0.c
** Last modified Date:      2006.11.18
** Last Version:            v1.0
** Description:             Դļ
** 
**------------------------------------------------------------------------------------------------------
** Created By:              Zhou Shaogang
** Created date:            2006.11.18
** Version:                 v1.0
** Descriptions:
**
**------------------------------------------------------------------------------------------------------
** Modified by:             Ni Likao 
** Modified date:           2007.10.20 
** Version:                 v1.1
** Description:
**
********************************************************************************************************/

#include "uart0.h"

INT8U ucBuffer[200] = {0};
INT8U ucBit = 0;
INT8U ucNum = 0;

/*********************************************************************************************************
** Function name:           Uart0Init
** Descriptions:            ʼUart0 
** input parameters:        BaudRate:   
**                          Prio:       жȼ
** Output parameters::      
** Returned value:          TRUE :      ɹ
**                          FALSE:      ʧ
** Created by:              Zhou Shaogang
** Created Date:            2006.11.18
**--------------------------------------------------------------------------------------------------------
** Modified by:             Ni Likao 
** Modified date:           2007.10.20 
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
INT8U Uart0Init (INT32U  BaudRate, INT8U  Prio)
{
    if (BaudRate > 115200) {                                            /*  ̫ߣ󷵻       */
        return(FALSE);
    }
    SysCtlPeripheralEnable(SYSCTL_PERIPH_UART0);                        /*  ʹܴ0Χ豸          */
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);                        /*  ʹGPIOA                  */
    GPIOPinTypeUART(GPIO_PORTA_BASE, GPIO_PIN_0 | GPIO_PIN_1);          /*  PA0,PA1ΪRXD0,TXD0     */
  
    UARTConfigSet(UART0_BASE, BaudRate, (UART_CONFIG_WLEN_8 |           /*  ô08λݣ1λʼ*/
                                                                        /*  λ1λֹͣλû  */
                                         UART_CONFIG_STOP_ONE |
                                         UART_CONFIG_PAR_NONE) & 0xFFFFFFEF);

    UARTFifoLevelSet(UART0_BASE, 4, 4);
    IntEnable(INT_UART0);                                               /*  ʹܴ0ϵͳж           */
    UARTIntEnable(UART0_BASE, UART_INT_RX | UART_INT_RT);               /*  ʹܴ0жϺͽճʱ */
                                                                        /*  ж                        */
    IntPrioritySet(INT_UART0, Prio);                                    /*  жȼ              */
    UARTEnable(UART0_BASE);                                
    return(TRUE);
}


/*********************************************************************************************************
** Function name:           Uart0Send
** Descriptions:            Ͷֽ
** input parameters:        Buffer:ݴ洢λ
**                          NByte:ݸ
** Output parameters::      
** Returned value:          
** Created by:              Zhou Shaogang
** Created Date:            2006.11.18
**--------------------------------------------------------------------------------------------------------
** Modified by:             Ni Likao 
** Modified date:           2007.10.20 
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void Uart0Send (INT8U  *Buffer, INT16U  NByte)
{
    while (NByte) {
        if ( UARTSpaceAvail(UART0_BASE) ) {
            UARTCharNonBlockingPut(UART0_BASE, *Buffer++);
            NByte--;
        }
    }
    while ( !UARTTraFifoEmp(UART0_BASE) ) {
        ;
    }
}


/*********************************************************************************************************
** Function name:           UART0_ISR
**  Descriptions:           0жϷ
** input parameters:        
** Output parameters::      
** Returned value:          
** Created by:              Zhou Shaogang
** Created Date:            2006.11.18
**--------------------------------------------------------------------------------------------------------
** Modified by:             Ni Likao 
** Modified date:           2007.10.20 
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
void UART0_ISR (void)
{
    unsigned long ulStatus;
    ulStatus = UARTIntStatus(UART0_BASE, true);                         /*  ȡʹܵĴ0ж״̬   */
    UARTIntClear(UART0_BASE, ulStatus);                                 /*  ǰĴ0ж         */
    if((ulStatus & UART_INT_RT)||(ulStatus & UART_INT_RX)) {            /*  ж                    */
        ucBuffer[ucNum] = UARTCharNonBlockingGet(UART0_BASE);           /*  յ            */        
        ucNum++; 
    }
    ucBit = 1;
}

/*********************************************************************************************************
  END FILE
*********************************************************************************************************/
