/****************************************Copyright (c)****************************************************
**                            Guangzhou ZHIYUAN electronics Co.,LTD.
**
**                                 http://www.embedtools.com
**
**------File Info-----------------------------------------------------------------------------------------
** File name:               main.c
** Latest modified Date:    2008-07-22
** Latest Version:          1.0
** Descriptions:            Something about this file
**
**--------------------------------------------------------------------------------------------------------
** Created by:              չ
** Created date:            2008-07-22
** Version:                 1.0
** Descriptions:
**
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
** Version:
** Descriptions:
**
*********************************************************************************************************/
#include "hw_types.h"
#include "hw_memmap.h"
#include "hw_gpio.h"
#include "sysctl.h"
#include "hw_flash.h"
#include "hw_ints.h"
#include "timer.h"
#include "interrupt.h"
#include "gpio.h"

#include "dataType.h"
#include "LTM024D130.h"
#include "gImage.h"
#include "main.h"


/*********************************************************************************************************
Timer
*********************************************************************************************************/
#define  T0_A                   TIMER0_BASE , TIMER_A
#define  T0_CFG_32_PER          TIMER0_BASE , TIMER_CFG_32_BIT_PER
#define  T0_A_INT_TIMEOUT       TIMER0_BASE , TIMER_TIMA_TIMEOUT


/*********************************************************************************************************
ȫֵϵͳʱӱ
*********************************************************************************************************/
volatile unsigned long  GulSysClock  =  12000000UL;


volatile INT32U GulDelayMs;


/*********************************************************************************************************
ͼ
*********************************************************************************************************/
#define V_INDEXOF    30                                                 /* ͼƬƫ         */

#define X0           ((240 - IMAGE_WIDTH) / 2)                          /* IMAGE_WIDTHgImage.hж  */
#define Y0           ((320 - IMAGE_HIGH)  / 2 - V_INDEXOF)              /* IMAGE_HIGHgImage.hж   */
#define X1           ((240 - IMAGE_WIDTH) / 2 + IMAGE_WIDTH - 1)
#define Y1           ((320 - IMAGE_HIGH)  / 2 + IMAGE_HIGH - 1 - V_INDEXOF)
const RECTANGLE GtFullZoon = {0,0,239,319,0,0};                         /* ȫ                 */
const RECTANGLE GtImageZoon = {X0, Y0, X1, Y1, 0, 0};                   /* ͼƬʾ             */



/*********************************************************************************************************
** Function name:           main
** Descriptions:            ÷ʾFTFҺʾͼƬַ
** input parameters:        
** output parameters:       
** Returned value:          
** Created By:              չ
** Created date:            2008.11.26
**--------------------------------------------------------------------------------------------------------
** Modified by:
** Modified date:
**--------------------------------------------------------------------------------------------------------
*********************************************************************************************************/
int  main(void)
{
    //unsigned short usColor=0xFFFF;
    //jtagWait();                                                       /* ֹJTAGʧЧҪ         */
    GulSysClock  =  clockInit();                                        /* ȡϵͳʱӣλHz       */
    timer0Init();                                                       /* ʱʼ                 */
    tftLcdInit();
    ledInit();
    while (1) {
        rectFill((RECTANGLE *)&GtFullZoon, WHITE);                      /* ɫ                 */
        writeString("LTM024D130 TFTҺʵ\r\n        EasyARM1138",20,80,RED);
                                                                        /* ı                 */
        //pixelDraw(100, 140, RED);                                       /*                          */
        //usColor = pixelRead(100,140);
        //lineDrawH(80, 230, 50, usColor);                                /*                        */
        //lineDrawV(200, 10, 210, BLUE);                                  /*                        */
        
        delayMs(2000);                                                  /* 2s                           */
        ledToggle(LED3);                                                /* ָʾȡ                   */
        rectFill((RECTANGLE *)&GtFullZoon, WHITE);                      /* ɫ                 */
        pictureFill((RECTANGLE *)&GtImageZoon, (unsigned short *)gImage, 128 * 230);
                                                                        /* ͼƬ                     */
        writeString("Ϊϰߣרעɾ룡",20,220,RED);   /* ı                 */
        
        delayMs(2000);                                                  /* 2s                           */
        ledToggle(LED3);                                                /* ȡָʾ                   */
    }
}


/*********************************************************************************************************
LEDʼ
*********************************************************************************************************/
void ledInit(void)
{
    SysCtlPeriEnable(LED_PERI);                                         /* ʹLEDڵGPIO˿        */
    GPIOPinTypeOut(LED3);                                               /* LED1ڹܽΪ       */
    ledOn(LED3);                                                        /* ϨLED1                     */
}


/*********************************************************************************************************
ϵͳʱӳʼʱƵʣλHz
*********************************************************************************************************/
unsigned long clockInit(void)
{
    #if PLL_EN == 0                                                     /* Not use PLL ʹPLL        */
    SysCtlClockSet(CCLK_DIV | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | EXT_CLK);
                                                                        /* System clock=                */
                                                                        /* EXT_CLK/CCLK_DIV             */
                                                                        /* ϵͳʱ=EXT_CLK/CCLK_DIV    */
    SysCtlLDOSet(SYSCTL_LDO_2_25V);                                     /* LDOѹ              */
    
    #else                                                               /* Use PLL ʹPLL              */
    SysCtlLDOSet(SYSCTL_LDO_2_75V);                                     /* LDOѹ              */
    SysCtlClockSet(CCLK_DIV | SYSCTL_USE_PLL | SYSCTL_OSC_MAIN | EXT_CLK);
                                                                        /* System clock=200MHz/CCLK_DIV */
                                                                        /* ϵͳʱ=200MHz/CCLK_DIV     */
    #endif
    
    return(SysCtlClockGet());                                           /* صǰϵͳʱƵ       */
}


/*********************************************************************************************************
** ʱжϷ
** ÿжһ
*********************************************************************************************************/
void  Timer0A_ISR(void)
{
    TimerIntClear(T0_A_INT_TIMEOUT);                                    /* ʱʱжϣҪ   */
    if (GulDelayMs < 0xFFFFFFFFUL) {
        GulDelayMs++;                                                   /* delayMs()㣬  */
                                                                        /* ȷʱ                     */
    }
}


/*********************************************************************************************************
ȷʱ GulDelayMsɶʱжÿ1ms1
*********************************************************************************************************/
void  delayMs(unsigned long  ulVal)
{
    GulDelayMs = 0;
    while (GulDelayMs < ulVal);
}



/*********************************************************************************************************
ʱʼ
*********************************************************************************************************/
void  timer0Init(void)
{
    IntRegister(INT_TIMER0A, Timer0A_ISR);                              /* עжϷ             */
    
    SysCtlPeriEnable(SYSCTL_PERIPH_TIMER0);                             /* ʹܶʱģ               */
    TimerConfigure(T0_CFG_32_PER);                                      /* öʱΪ32λڶʱ   */
    TimerLoadSet(T0_A , GulSysClock/1000);                              /* öʱֵ               */
    TimerIntEnable(T0_A_INT_TIMEOUT);                                   /* ʹܶʱʱж           */
    IntEnable(INT_TIMER0A);                                             /* ʹܶʱж               */
    IntMasterEnable();                                                  /* ʹܴж               */
    GulDelayMs = 0;
    TimerEnable(T0_A);                                                  /* ʹܶʱ               */
}


/*********************************************************************************************************
ֹJTAGʧЧ
*********************************************************************************************************/
void  jtagWait(void)
{
    SysCtlPeriEnable(KEY_PERI);                                         /* ʹKEYڵGPIO˿        */
    GPIOPinTypeIn(KEY_BASE , KEY_PIN);                                  /* KEYڹܽΪ        */
    while (keyGet() == 0) {
        ;
    }
    SysCtlPeriDisable(KEY_PERI);                                        /* ֹKEYڵGPIO˿        */
}

/*********************************************************************************************************
** End of File
*********************************************************************************************************/
